// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v1alpha1 "github.com/openshift/azure-disk-csi-driver-operator/pkg/apis/operator/v1alpha1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeAzureDiskDrivers implements AzureDiskDriverInterface
type FakeAzureDiskDrivers struct {
	Fake *FakeCsiV1alpha1
}

var azurediskdriversResource = schema.GroupVersionResource{Group: "csi.openshift.io", Version: "v1alpha1", Resource: "azurediskdrivers"}

var azurediskdriversKind = schema.GroupVersionKind{Group: "csi.openshift.io", Version: "v1alpha1", Kind: "AzureDiskDriver"}

// Get takes name of the azureDiskDriver, and returns the corresponding azureDiskDriver object, and an error if there is any.
func (c *FakeAzureDiskDrivers) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha1.AzureDiskDriver, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootGetAction(azurediskdriversResource, name), &v1alpha1.AzureDiskDriver{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.AzureDiskDriver), err
}

// List takes label and field selectors, and returns the list of AzureDiskDrivers that match those selectors.
func (c *FakeAzureDiskDrivers) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha1.AzureDiskDriverList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootListAction(azurediskdriversResource, azurediskdriversKind, opts), &v1alpha1.AzureDiskDriverList{})
	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1alpha1.AzureDiskDriverList{ListMeta: obj.(*v1alpha1.AzureDiskDriverList).ListMeta}
	for _, item := range obj.(*v1alpha1.AzureDiskDriverList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested azureDiskDrivers.
func (c *FakeAzureDiskDrivers) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewRootWatchAction(azurediskdriversResource, opts))
}

// Create takes the representation of a azureDiskDriver and creates it.  Returns the server's representation of the azureDiskDriver, and an error, if there is any.
func (c *FakeAzureDiskDrivers) Create(ctx context.Context, azureDiskDriver *v1alpha1.AzureDiskDriver, opts v1.CreateOptions) (result *v1alpha1.AzureDiskDriver, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootCreateAction(azurediskdriversResource, azureDiskDriver), &v1alpha1.AzureDiskDriver{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.AzureDiskDriver), err
}

// Update takes the representation of a azureDiskDriver and updates it. Returns the server's representation of the azureDiskDriver, and an error, if there is any.
func (c *FakeAzureDiskDrivers) Update(ctx context.Context, azureDiskDriver *v1alpha1.AzureDiskDriver, opts v1.UpdateOptions) (result *v1alpha1.AzureDiskDriver, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateAction(azurediskdriversResource, azureDiskDriver), &v1alpha1.AzureDiskDriver{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.AzureDiskDriver), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeAzureDiskDrivers) UpdateStatus(ctx context.Context, azureDiskDriver *v1alpha1.AzureDiskDriver, opts v1.UpdateOptions) (*v1alpha1.AzureDiskDriver, error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateSubresourceAction(azurediskdriversResource, "status", azureDiskDriver), &v1alpha1.AzureDiskDriver{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.AzureDiskDriver), err
}

// Delete takes name of the azureDiskDriver and deletes it. Returns an error if one occurs.
func (c *FakeAzureDiskDrivers) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewRootDeleteAction(azurediskdriversResource, name), &v1alpha1.AzureDiskDriver{})
	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeAzureDiskDrivers) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewRootDeleteCollectionAction(azurediskdriversResource, listOpts)

	_, err := c.Fake.Invokes(action, &v1alpha1.AzureDiskDriverList{})
	return err
}

// Patch applies the patch and returns the patched azureDiskDriver.
func (c *FakeAzureDiskDrivers) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.AzureDiskDriver, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootPatchSubresourceAction(azurediskdriversResource, name, pt, data, subresources...), &v1alpha1.AzureDiskDriver{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.AzureDiskDriver), err
}
